unit Geredata;
{Unite qui sert a gerer le type TImg_.. qui contient les datas de l'image}
interface
uses  SysUtils;

const MaxCCDX=300000;
      MaxCCDY=300000;
      PA_SmallInt= 3;
      PA_Single  = 6;
      PA_Byt     = 2;
      PA_Compl   = 11;

     MaxDimVect        = 400;
      DimVec            = MaxDimVect*2;
      DimDemiVec        = MaxDimVect;

      DimMat            = MaxDimVect*2; // Max Matrix Dim
      DimDemiMat        = MaxDimVect;


type
      TTypeData=set of 0..11;
      Complexe=record
                 Re,Im:Single
              end;

Const

      NULLComplex       :Complexe=(Re:0;Im:0);

type

     TVecteur= Array [1..DimVec] of Double;
     TMatrice= Array [1..DimMat,1..DimMat] of Double;
     PMatrice= ^TMatrice;
     PVecteur= ^TVecteur;


     {Entiers Cours}
     TLig_Int=array[1..MaxCCDX] of SmallInt;
     PLig_Int=^TLig_Int;
     TImg_Int=array[1..MaxCCDY] of PLig_Int;
     PImg_Int=^TImg_Int;
     TTab_PImg_Int=array[1..MaxInt div SizeOf(Pointer)] of PImg_Int;
     PTab_PImg_Int=^TTab_PImg_Int;

     {Entiers Mots}
     TLig_Wrd=array[1..MaxCCDX] of Word;
     PLig_Wrd=^TLig_Wrd;
     TImg_Wrd=array[1..MaxCCDY] of PLig_Wrd;
     PImg_Wrd=^TImg_Wrd;

     {Entiers}
     TLig_Integer=array[1..MaxCCDX] of Integer;
     PLig_Integer=^TLig_Integer;
     TImg_Integer=array[1..MaxCCDY] of PLig_Integer;
     PImg_Integer=^TImg_Integer;
     TTab_PImg_Integer=array[1..MaxInt div SizeOf(Pointer)] of PImg_Integer;
     PTab_PImg_Integer=^TTab_PImg_Integer;

     {LongWord}
     TLig_LongWord=array[1..MaxCCDX] of LongWord;
     PLig_LongWord=^TLig_LongWord;
     TImg_LongWord=array[1..MaxCCDY] of PLig_LongWord;
     PImg_LongWord=^TImg_LongWord;
     TTab_PImg_LongWord=array[1..MaxInt div SizeOf(Pointer)] of PImg_LongWord;
     PTab_PImg_LongWord=^TTab_PImg_LongWord;


     {Octets}
     TLig_Byt=array[1..MaxCCDX] of Byte;
     PLig_Byt=^TLig_Byt;
     TImg_Byt=array[1..MaxCCDY] of PLig_Byt;
     PImg_Byt=^TImg_Byt;
     TTab_PImg_Byt=array[1..MaxInt div SizeOf(Pointer)] of PImg_Byt;
     PTab_PImg_Byt=^TTab_PImg_Byt;

     {Booleans}
     TLig_Bool=array[1..MaxCCDX] of Boolean;
     PLig_Bool=^TLig_Bool;
     TImg_Bool=array[1..MaxCCDY] of PLig_Bool;
     PImg_Bool=^TImg_Bool;
     TTab_PImg_Bool=array[1..MaxInt div SizeOf(Pointer)] of PImg_Bool;
     PTab_PImg_Bool=^TTab_PImg_Bool;



     {Reels 32 bits}
     TLig_Single=array[1..MaxCCDX] of Single;
     PLig_Single=^TLig_Single;
     TImg_Single=array[1..MaxCCDY] of PLig_Single;
     PImg_Single=^TImg_Single;
     TTab_PImg_Single=array[1..MaxInt div SizeOf(Pointer)] of PImg_Single;
     PTab_PImg_Single=^TTab_PImg_Single;

     {Reels 64 bits}
     TLig_Double=array[1..MaxCCDX] of Double;
     PLig_Double=^TLig_Double;
     TImg_Double=array[1..MaxCCDY] of PLig_Double;
     PImg_Double=^TImg_Double;


     {Complexes}
     TLig_Compl=array[1..MaxCCDX] of Complexe;
     PLig_Compl=^TLig_Compl;
     TImg_Compl=array[1..MaxCCDY] of PLig_Compl;
     PImg_Compl=^TImg_Compl;
     TTab_PImg_Compl=array[1..MaxInt div SizeOf(Pointer)] of PImg_Compl;
     PTab_PImg_Compl=^TTab_PImg_Compl;

     {TVector}
     TLig_Vecteur=array[1..MaxCCDX] of TVecteur;
     PLig_Vecteur=^TLig_Vecteur;
     TImg_Vecteur=array[1..MaxCCDY] of PLig_Vecteur;
     PImg_Vecteur=^TImg_Vecteur;


     {POinter}
     TLig_Pointer=array[1..MaxCCDX] of Pointer;
     PLig_Pointer=^TLig_Pointer;
     TImg_Pointer=array[1..MaxCCDY] of PLig_Pointer;
     PImg_Pointer=^TImg_Pointer;


     {Block pixel}
     TBlock=array[1..MaxInt div Sizeof(Single)] of single;
     PBlock=^TBlock;


     EImgVide=class(Exception);

     TOrderByte   = record
                       Values:Array [1..MaxCCDX] of byte;
                       Index :Integer
                    end;


procedure GetImage(LargX,LargY:Integer;TypeData:Integer;var Image;NbrePlan:Integer);
procedure FreeImage(LargX,LargY:Integer;TypeData:Integer;var Image;NbrePlan:Integer);

implementation


procedure GetImage(LargX,LargY:Integer;TypeData:Integer;var Image;NbrePlan:Integer);
var I,K:Integer;
    Img_Byt           :PImg_Byt;
    Img_Int           :PImg_Int;
    Img_Integer       :PImg_Integer;
    Img_Single        :PImg_Single;
    Img_Compl         :PImg_Compl;
    Tab_PImg_Byt      :PTab_PImg_Byt;
    Tab_PImg_Int      :PTab_PImg_Int;
    Tab_PImg_Integer  :PTab_PImg_Integer;
    Tab_PImg_Single   :PTab_PImg_Single;
    Tab_PImg_Compl    :PTab_PImg_Compl;
begin 
 case TypeData of
  2:if NbrePlan=1 then
    begin
     getmem(Img_Byt,LargY*4);
     for I:=1 to LargY do
      getmem(Img_Byt^[I],LargX);
     PImg_Byt(Image):=Img_Byt;
    end
    else
    begin
     getmem(Tab_PImg_Byt,4*NbrePlan);
     for K:=1 to NbrePlan do
     begin
      getmem(Tab_PImg_Byt^[K],LargY*4);
      for I:=1 to LargY do
       getmem(Tab_PImg_Byt^[K]^[I],LargX);
     end;
     PTab_PImg_Byt(Image):=Tab_PImg_Byt;
    end;
  3:if NbrePlan=1 then
    begin
     getmem(Img_Int,LargY*4);
     for I:=1 to LargY do
      getmem(Img_Int^[I],LargX*2);
     PImg_Int(Image):=Img_Int;
    end
    else
    begin
     getmem(Tab_PImg_Int,4*NbrePlan);
     for K:=1 to NbrePlan do
     begin
      getmem(Tab_PImg_Int^[K],LargY*4);
      for I:=1 to LargY do
       getmem(Tab_PImg_Int^[K]^[I],LargX*2);
     end;
     PTab_PImg_Int(Image):=Tab_PImg_Int;
    end;
  4:if NbrePlan=1 then
    begin
     getmem(Img_Integer,LargY*4);
     for I:=1 to LargY do
      getmem(Img_Integer^[I],LargX*4);
     PImg_Integer(Image):=Img_Integer;
    end
    else
    begin
     getmem(Tab_PImg_Integer,4*NbrePlan);
     for K:=1 to NbrePlan do
     begin
      getmem(Tab_PImg_Integer^[K],LargY*4);
      for I:=1 to LargY do
       getmem(Tab_PImg_Integer^[K]^[I],LargX*4);
     end;
     PTab_PImg_Integer(Image):=Tab_PImg_Integer;
    end;
  6:if NbrePlan=1 then
    begin
     getmem(Img_Single,LargY*4);
     for I:=1 to LargY do
      getmem(Img_Single^[I],LargX*4);
     PImg_Single(Image):=Img_Single;
     PImg_Single(Image):=Img_Single;
    end
    else
    begin
     getmem(Tab_PImg_Single,4*NbrePlan);
     for K:=1 to NbrePlan do
     begin
      getmem(Tab_PImg_Single^[K],LargY*4);
      for I:=1 to LargY do
       getmem(Tab_PImg_Single^[K]^[I],LargX*4);
     end;
     PTab_PImg_Single(Image):=Tab_PImg_Single;
    end;
 11:if NbrePlan=1 then
    begin
     getmem(Img_Compl,LargY*4);
     for I:=1 to LargY do
      getmem(Img_Compl^[I],LargX*SizeOf(Complexe));
     PImg_Compl(Image):=Img_Compl;
    end
    else
    begin
     getmem(Tab_PImg_Compl,4*NbrePlan);
     for K:=1 to NbrePlan do
     begin
      getmem(Tab_PImg_Compl^[K],LargY*4);
      for I:=1 to LargY do
       getmem(Tab_PImg_Compl^[K]^[I],LargX*SizeOf(Complexe));
     end;
     PTab_PImg_Compl(Image):=Tab_PImg_Compl;
    end;
 end;
end;


procedure FreeImage(LargX,LargY:Integer;TypeData:Integer;var Image;NbrePlan:Integer);
var I,K:Integer;
    Img_Byt           :PImg_Byt;
    Img_Int           :PImg_Int;
    Img_Integer       :PImg_Integer;
    Img_Single        :PImg_Single;
    Img_Compl         :PImg_Compl;
    Tab_PImg_Byt      :PTab_PImg_Byt;
    Tab_PImg_Int      :PTab_PImg_Int;
    Tab_PImg_Integer  :PTab_PImg_Integer;
    Tab_PImg_Single   :PTab_PImg_Single;
    Tab_PImg_Compl    :PTab_PImg_Compl;
begin
  case TypeData of
  2:if NbrePlan=1 then
    begin
     Img_Byt:=PImg_Byt(Image);
     for I:=1 to LargY do
      freemem(Img_Byt^[I],LargX);
     freemem(Img_Byt,LargY*4);
    end
    else
    begin
     Tab_PImg_Byt:=PTab_PImg_Byt(Image);
     for K:=1 to NbrePlan do
     begin
      for I:=1 to LargY do
       freemem(Tab_PImg_Byt^[K]^[I],LargX);
      freemem(Tab_PImg_Byt^[K],LargY*4);
     end;
     freemem(Tab_PImg_Byt,4*NbrePlan);
    end;
  3:if NbrePlan=1 then
    begin
     Img_Int:=PImg_Int(Image);
     for I:=1 to LargY do
      freemem(Img_Int^[I],LargX*2);
     freemem(Img_Int,LargY*4);
    end
    else
    begin
     Tab_PImg_Int:=PTab_PImg_Int(Image);
     for K:=1 to NbrePlan do
     begin
      for I:=1 to LargY do
       freemem(Tab_PImg_Int^[K]^[I],LargX*2);
      freemem(Tab_PImg_Int^[K],LargY*4);
     end;
     freemem(Tab_PImg_Int,4*NbrePlan);
    end;
  4:if NbrePlan=1 then
    begin
     Img_Integer:=PImg_Integer(Image);
     for I:=1 to LargY do
      freemem(Img_Integer^[I],LargX*4);
     freemem(Img_Integer,LargY*4);
    end
    else
    begin
     Tab_PImg_Integer:=PTab_PImg_Integer(Image);
     for K:=1 to NbrePlan do
     begin
      for I:=1 to LargY do
       freemem(Tab_PImg_Integer^[K]^[I],LargX*4);
      freemem(Tab_PImg_Integer^[K],LargY*4);
     end;
     freemem(Tab_PImg_Integer,4*NbrePlan);
    end;
  6:if NbrePlan=1 then
    begin
     Img_Single:=PImg_Single(Image);
     for I:=1 to LargY do
      freemem(Img_Single^[I],LargX*4);
     freemem(Img_Single,LargY*4);
    end
    else
    begin
     Tab_PImg_Single:=PTab_PImg_Single(Image);
     for K:=1 to NbrePlan do
     begin
      for I:=1 to LargY do
       freemem(Tab_PImg_Single^[K]^[I],LargX*4);
      freemem(Tab_PImg_Single^[K],LargY*4);
     end;
     freemem(Tab_PImg_Single,4*NbrePlan);
    end;
 11:if NbrePlan=1 then
    begin
     Img_Compl:=PImg_Compl(Image);
     for I:=1 to LargY do
      freemem(Img_Compl^[I],LargX*SizeOf(Complexe));
     freemem(Img_Compl,LargY*4);
    end
    else
    begin
     Tab_PImg_Compl:=PTab_PImg_Compl(Image);
     for K:=1 to NbrePlan do
     begin
      for I:=1 to LargY do
       freemem(Tab_PImg_Compl^[K]^[I],LargX*SizeOf(Complexe));
      freemem(Tab_PImg_Compl^[K],LargY*4);
     end;
     freemem(Tab_PImg_Compl,4*NbrePlan);
    end;
 end;
 Pointer(Image):=Nil;
end;
end.
