unit testCPA;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    BitBtnLoadAndSave: TBitBtn;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    Image: TImage;
    procedure BitBtnLoadAndSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses testDLL, testVisu;

{$R *.DFM}


procedure TForm1.BitBtnLoadAndSaveClick(Sender: TObject);
var HighValue,LowValue:TThreshold;
    Infos_Image:TInfos_Image;
    SizeX,SizeY:Integer;
    TypeData:Integer;
    Image:Pointer;
    NbrePlan:Integer;
    ErrorCode:Integer;
begin
 //Load an image
 OpenDialog.Filter:='PRISM compressed files v.4D (*.CPA)|*.cpa';
 if OpenDialog.Execute then
 begin
  LoadCPA(PChar(Opendialog.Files[0]),
          HighValue,LowValue,Infos_Image,
          SizeX,SizeY,TypeData,Image,NbrePlan,
          ErrorCode);
  if ErrorCode<>0 then
   showMessage('Unable to read this file (Error code='+IntToStr(ErrorCode)+')');

 if ErrorCode=0 then
 begin  
  try
  Self.Image.Picture.Bitmap.Handle:=GetVisuBitMap(SizeX,SizeY,HighValue,LowValue,0,TypeData,Image,0,NbrePLan);
  except
  end;


  //Save an image
  SaveDialog.Options:=[ofHideReadOnly];
  SaveDialog.FileName:=Opendialog.Files[0];
  if SaveDialog.Execute then
  begin
   SaveCPA(PChar(SaveDialog.Files[0]),
            HighValue,LowValue,Infos_Image,
            SizeX,SizeY,TypeData,Image,NbrePlan,
            ErrorCode);

   if ErrorCode<>0 then
    showMessage('Unable to read this file (Error code='+IntToStr(ErrorCode)+')');
   end;
  end;
 end; 
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 self.caption:='Fichier CPA : '+VersionCPA;
end;

end.
