unit fileType;

interface
uses Types;

type  

   TThreshold=array[0..2] of extended;


   TOrientation=(S,SW,W,NW,N,NE,E,SE);

   TInfos_Image=packed record
    Date        :TDateTime ;
    Heure       :TDateTime ;
    Pose        :Integer   ;  // Ms !!

    ObjectName  :String[80];
    Telescope   :string[80];
    Observateur :string[80];
    Camera      :string[80];
    Filtre      :string[80];
    Observatory :string[80];
    Focale      :Double;

    Alpha       :Double;
    Delta       :Double;
    CenterPixXAstrometrie:Integer;
    CenterPixYAstrometrie:Integer;
    PixX        :Double;
    PixY        :Double;

    DebX,DebY,
    FinX,FinY   :Integer;
    Miroir_X    :Boolean;
    Miroir_Y    :Boolean;
    BinX,BinY   :Integer;

    Wavelength    : Double ;
    Bandwidth     : Double ;
    Flux          : Double ;
    PhotometrieEtalonnage : Boolean ;
    Magnitude_Ref : Double ;
    ErrFlux_Ref   : Double ;
    Flux_Ref      : Double ;

    Diametre      : Double ;
    Offset        : Double ;
    FacteurCVF    : Double ;
    TemperatureCCD: Double ;
    TemperatureExt: Double ;
    Seeing        : Double;
    Latitude,
    Longitude     : Double;

    Orientation:TOrientation;

    TempsLectureCCD : Double;
    TDImode         : Boolean;
    TempLectureLigne: Double ;
    PhotometricCal  : Boolean;
    AngleCCD        : Double ;

    Comment:array[1..4] of string[80];
   end;


implementation

end.
