unit tools;

interface

uses comctrls;


function  Max(Int1,Int2:Integer):Integer; overload;
function  Min(Int1,Int2:Integer):Integer; overload;
function  Max(Int1,Int2:LongWord):LongWord; overload;
function  Min(Int1,Int2:LongWord):LongWord; overload;
function  Max(D1,D2:Double):Double; overload;
function  Min(D1,D2:Double):Double; overload;



type


     TProcessProgress=class
     private
      Gain,Offset:Single;
     public
      constructor Create;
      procedure progress(ProgressValue,ProgressMax:Integer); virtual; abstract;
      procedure SetProgressPonderation(Gain,Offset:Single); virtual;
     end;



implementation


function  Max(Int1,Int2:Integer):Integer;
begin
 if Int1<=Int2 then
  Result:=Int2
 else
  Result:=Int1;
end;

function  Min(Int1,Int2:Integer):Integer;
begin
 if Int1>Int2 then
  Result:=Int2
 else
  Result:=Int1;
end;

function  Max(Int1,Int2:LongWord):LongWord;
begin
 if Int1<=Int2 then
  Result:=Int2
 else
  Result:=Int1;
end;

function  Min(Int1,Int2:LongWord):LongWord;
begin
 if Int1>Int2 then
  Result:=Int2
 else
  Result:=Int1;
end;

function  Max(D1,D2:Double):Double;
begin
 if D1>D2 then
  Result:=D1
 else
  Result:=D2;
end;

function  Min(D1,D2:Double):Double;
begin
 if D1<=D2 then
  Result:=D1
 else
  Result:=D2;
end;





constructor TProcessProgress.Create;
begin
 inherited Create;
 Gain:=1;
 Offset:=0;
end;
procedure TProcessProgress.SetProgressPonderation(Gain,Offset:Single);
begin
 Self.Gain:=Gain;
 Self.Offset:=Offset;
end;


end.
